import java.util.*;

/** Klasse zur Speicherung der Daten eines Bannertextes
  *
  * @author Bernhard Fiser 0109815
  */
public class BannerElement
{
	private int	zoom;
	private String	text;

	/** Initialisierung des Bannerelements */
	public BannerElement()
	{
		this.zoom = 1;
		this.text = "";
	}

	/** Zoomfaktor zurckliefern
	  * @return int zoom : Zoomfaktor */
	public int getZoom()
	{
		return(this.zoom);
	}

	/** Text des Bannerelements zurckliefern 
	  * @return String txt : Bannertext */
	public String getText()
	{
		return(this.text);
	}

	/** Methode um einen String in ein Bannerelement zu 
	  * konvertieren.
	  * @return false : falls ein Fehler bei der Konvertierung aufgetreten ist
	  * @return true : falls Konvertierung erfolgreich */
	public boolean parseLine(String s)
	{
		StringTokenizer st;
		int		i;
		String		t;

		/* Stringtokenizer initialisieren */
		i = 0;
		st = new StringTokenizer(s, " ");
		while(st.hasMoreTokens())
		{
			t = st.nextToken();
			switch(i)
			{
				/* Erstes Element enthlt den Zoomfaktor */
				case 0 :
					/* falls Integerkovertierung nicht mglich,
					 * Fehler zurckgeben */
					try { this.zoom = Integer.parseInt(t); }
					catch (NumberFormatException e) { return(false); }
					break;

				/* Die restlichen Element wieder verketten */
				default :
					this.text += t + " ";
			}
			/* Elementzhler erhhen */
			i++;
		}
		/* Sollten weniger als 2 Elemente im String gewesen sein,
		 * dann Fehler zurckgeben */
		if (i < 2)
			return(false);
		/* Andernfalls alles OK */
		return(true);
	}
}
