import java.util.*;
import java.awt.*;

/** Klasse zur Speicherung eines Linienelements
  * eines Zeichens.
  *
  * @author Bernhard Fiser 0109815
  */
public class CharLineElement extends CharElement
{
	private int	coord[];

	/** Initialisiert das LinienElement */
	public CharLineElement()
	{
		int	i;

		/* Koordinationfeld erzeugen und auf 0 setzen */
		coord = new int[4];
		for (i = 0; i < 4; i++)
			coord[i] = 0;
	}

	/** Daten aus dem String s in das Koordinationfeld bernehmen */
	public boolean parseLine(String s)
	{
		StringTokenizer	st;
		int		i;
		String		t;

		/* StringTokenizer inititalisieren,
		 * Trennzeichen ' ' */
		i = 0;
		st = new StringTokenizer(s, " ");
		while (st.hasMoreTokens())
		{
			t = st.nextToken();
			switch (i)
			{
				/* Das erste Element bestimmt den Typ.
				 * Falls nicht vom Type 'strich', dann Fehler
				 * zurckgeben */
				case 0 :
					if (t.compareToIgnoreCase("strich") != 0)
						return(false);
					break;
				/* Die nchsten 4 Elemente bestimmen die Koordinaten
				 * x1, y1, x2 und y2. */
				case 1 :
				case 2 :
				case 3 :
				case 4 :
					/* In Integer umkonvertieren, und Fehler zurckgeben
					 * falls Konvertierung nicht mglich */
					try { this.coord[i - 1] = Integer.parseInt(t); }
					catch (NumberFormatException e) { return(false); }
					/* Bei einer negativen Koordinate ebenfalls einen
					 * Fehler zurckgeben */
					if (this.coord[i - 1] < 0)
						return(false);
					break;
				/* Sollten mehr als diese 5 Elemente existieren, 
				 * dann Fehler zurckgeben */
				default :
					return(false);
			}
			/* Element- (Token-) zhler erhhen */
			i++;
		}
		/* Sollten weniger als 5 Elemente (Tokens) im String enthalten sein,
		 * dann Fehler zurckgeben */
		if (i < 5)
			return(false);
		/* Andernfalls alles OK */
		return(true);
	}

	/** Dieses Element graphisch darstellen */
	public void draw(int x, int y, int zoom, Graphics g)
	{
		/* Koordinatenfelder fr die Funktion fillPolygon */
		int xc[] = new int[5];
		int yc[] = new int[5];
		int i;

		/* Winkel steiler als 45 */
		if (this.coord[2] - this.coord[0] < this.coord[3] - this.coord[1])
		{
			/* Berechnung der Koordinatenpunkte. Details siehe bungsangabe */
			xc[0] = (this.coord[0] + 1) * zoom;
			yc[0] = this.coord[1] * zoom;

			xc[1] = (this.coord[2] + 1) * zoom;
			yc[1] = (this.coord[3] + 1) * zoom;

			xc[2] = this.coord[2] * zoom;
			yc[2] = yc[1];

			xc[3] = this.coord[0] * zoom;
			yc[3] = yc[0];
		}
		/* Winkel flacher als 45 */
		else
		{
			/* Berechnung der Koordinatenpunkte. Details siehe bungsangabe */
			xc[0] = this.coord[0] * zoom;
			yc[0] = this.coord[1] * zoom;

			xc[1] = (this.coord[2] + 1) * zoom;
			yc[1] = this.coord[3] * zoom;

			xc[2] = xc[1];
			yc[2] = (this.coord[3] + 1) * zoom;

			xc[3] = xc[0];
			yc[3] = (this.coord[1] + 1) * zoom;
		}

		/* Endpunkt auf Anfangspunkt setzen */
		xc[4] = xc[0];
		yc[4] = yc[0];

		/* Offset hinzufuegen (absolute Position des Elements auf dem Bildschirm) */
		for (i = 0; i < 5; i++)
		{
			xc[i] += x;
			yc[i] += y;
		}

		/* Zeichnen */
		g.setColor(Color.black);
		g.fillPolygon(xc, yc, xc.length);
	}
}
